{
    $Id: ctypes.inc,v 1.4 2004/04/26 16:53:19 peter Exp $
    This file is part of the Free Pascal run time library.
    Copyright (c) 2001 by Free Pascal development team

    Basic types for C interfacing. Check the 64-bit defines.

    See the file COPYING.FPC, included in this distribution,
    for details about the copyright.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

 **********************************************************************}

{***********************************************************************}
{                       POSIX TYPE DEFINITIONS                          }
{***********************************************************************}

Type
    { the following type definitions are compiler dependant }
    { and system dependant                                  }

    cInt8  = shortint;
    cUInt8 = byte;
    cUInt16= word;
    cInt16 = smallint;
    cInt32 = longint;
    cUInt32= cardinal;
    cInt64 = int64;
{$ifndef VER_1_0}
    cUInt64= qword;
{$else}
    cUInt64= int64;
{$endif}

    cuchar = byte;
    cInt   = longint;           { minimum range is : 32-bit    }
    cUInt  = Cardinal;          { minimum range is : 32-bit    }
{$ifdef cpu64}
    cLong  = int64;
    cuLong = qword;
{$else}
    cLong  = longint;
    cuLong = Cardinal;
{$endif}
    cshort = smallint;
    cushort= word;

    pcInt   = ^cInt;
    pcUInt  = ^cUInt;
    pcLong  = ^cLong;
    pculong = ^cuLong;
    pcshort = ^cshort;
    pcushort= ^cushort;

{
   $Log: ctypes.inc,v $
   Revision 1.4  2004/04/26 16:53:19  peter
     * use cpu64

   Revision 1.3  2003/09/16 21:20:40  marco
    * pointer's of some basetypes

   Revision 1.2  2002/12/18 16:43:26  marco
    * new unix rtl, linux part.....

   Revision 1.1  2002/11/09 22:39:28  marco
    * first version


}

